#!/bin/sh
die () {
  echo "*** 'mkconfig.sh' error: $*" 1>&2
  exit 1
}
[ -f makefile ] || die "run './configure.sh' first"
#ID=`git show|awk '{print $2; exit}'`
VERSION="`cat VERSION`"
CC="`sed -e '/^CC=/!d' -e 's,CC=,,' makefile`"
CFLAGS="`sed -e '/^CFLAGS=/!d' -e 's,CFLAGS=,,' makefile`"
COMPILER="`$CC --version|head -1`"
cat <<EOF
// Automatically generated by 'mkconfig.sh'.  Do not edit!
#include <stdio.h>
#include "sadical.h"
void sadical_print_banner (void) {
  fputs (
    "c SaDiCaL SAT Solver\n"
    "c Copyright (C) 2018 by Armin Biere JKU\n"
    "c\n"
    "c Version $VERSION $ID\n"
    "c Compiler $COMPILER\n"
    "c Options $CC $CFLAGS\n",
    stdout);
}
const char * sadical_get_version (void) { return "$VERSION"; }
EOF
